var htmlTagOpen = "&lt;";				var htmlOpen = '<SPAN class="html">' + htmlTagOpen + '</SPAN><SPAN class="html">' ;
var htmlTagClose = "&gt;";				var htmlClose = '</SPAN><SPAN class="html">' + htmlTagClose + '</SPAN>' ;

// this part is language dependent. Different values needed here for PHP, ASP...
var scriptDelimOpen = '&lt;%';
var scriptDelimClose = '%&gt;'
var scriptCommentOpen = "'";
var scriptCommentClose = "\n";

reserved = new stringArray(18);
reserved[1] = "end";
reserved[2] = "sub";
reserved[3] = "set";
reserved[4] = "do";
reserved[5] = "loop";
reserved[6] = "until";
reserved[7] = "while";
reserved[8] = "wend";
reserved[9] = "for";
reserved[10] = "each";
reserved[11] = "next";
reserved[12] = "function";
reserved[13] = "in";
reserved[14] = "true";
reserved[15] = "false";
reserved[16] = "if";
reserved[17] = "then";
reserved[18] = "else";
// end language dependent part

function formatScript(scr) {
	return _formatScript(scr);
}

function formatHtml(html) {	
	return _formatHtml(html);
}

function formatSyntax(text) {
	return _formatSyntax(text);
}


function stringArray(howMany) {
	this.length = howMany;
	for (var i = 1; i <= howMany; i++) {
		this[i] = '';
	}
}

function replace(s, src, trg) {
	var sp = s.split(src);
	return sp.join(trg);
}
function isRegChar(ch) {
	var resb = false;
	if ( (ch >= 'a') && (ch <= 'z') ) resb = true;
	if ( (ch >= 'A') && (ch <= 'Z') ) resb = true;
	if ( (ch >= '0') && (ch <= '9') ) resb = true;
	return resb;
}

function replaceWord(s, src, trg) {
	var sp = s.split(src);
	var resb = sp[0];
	for (var q = 1; q < sp.length; q++) {
		// check if character before and character after are seperation chars, or if src is just part of another word
		if ( (!isRegChar(sp[q].charAt(0) ) )  && (!isRegChar(resb.charAt(resb.length - 1) ) ) ) {
			resb = resb + "" + trg + "" + sp[q];
		} else {
			// alert("Kan [" + src + "] niet omzetten in [" + trg + "]");
			resb = resb + "" + src + "" + sp[q];
		}
	}
	return resb;
}

function markReservedWords(snippet) {
		for (var i = 1; i <= reserved.length; i++) {
			snippet = replaceWord(snippet, reserved[i], '<SPAN class="res">' + reserved[i] + '</SPAN>');
		}
		return snippet;
}

function markScriptComment(snippet) {
		comment = snippet.split(scriptCommentOpen);
		if (comment.length > 1) {
			for (var i = 1; i < comment.length; i ++) {
				commentEnd = comment[i].split(scriptCommentClose);
				comment[i] = commentEnd.join(scriptCommentClose + "</SPAN>");
			}
			snippet = comment.join('<SPAN class="comment">' + scriptCommentOpen);
		}
		return snippet;
}

function _formatScript(scr) {

	scr = replace(replace(scr, '<', '&lt;'), '>', '&gt;');

	var newScr = "";
	
	var idx1, idx2;
	var preQuote;
	var quoteChar = '"';
	
	while ( (idx1 = scr.indexOf(quoteChar)) > -1) {
		preQuote = scr.substring(0, idx1); 
		preQuote = markReservedWords(preQuote);
		
		preQuote = markScriptComment(preQuote);
		
		preQuote = replace(preQuote, "  ", " &nbsp;"); 
		newScr += preQuote + '<SPAN class="string">' + quoteChar;
		scr = scr.substring(idx1 + 1, scr.length);
		idx2 = scr.indexOf(quoteChar);
		if (idx2 == -1) idx2 = scr.length;
		newScr += scr.substring(0, idx2 + 1) + "</SPAN>";
		scr = scr.substring(idx2 + 1, scr.length);
	}
	newScr += replace(markScriptComment(markReservedWords(scr)), "  ", " &nbsp;");

	scr = newScr;
	scr = replace(scr, scriptDelimOpen, '<SPAN class="script">' + scriptDelimOpen + '</SPAN>');
	scr = replace(scr, scriptDelimClose, '<SPAN class="script">' + scriptDelimClose + '</SPAN>');
	
	return replace(scr, "\n", "<br>\n");
}

function _formatHtml(html) {
	
	html = replace(replace(html, '<', '&lt;'), '>', '&gt;');

	var newHtml = "", nonHtml = "";
	
	var oldHtml = html;
	
	var idx1, idx2;
	
	while ( (idx1 = html.indexOf(htmlTagOpen)) > -1) {
		idx2 = html.indexOf(htmlTagClose);
		
		if (idx1 > 0) nonHtml = html.substring(0, idx1); else nonHtml = "";

		idxScript = html.indexOf(scriptDelimOpen);
		if (idxScript > idx1 && idxScript < idx2) {
		}

		if (html.substring(idx1 + htmlTagOpen.length, idx1 + 3 + htmlTagOpen.length) == "!--") {
			// we have comment!
			newHtml = newHtml + nonHtml + '<SPAN class="comment">' + html.substring(idx1, idx2 + htmlTagClose.length) + "</SPAN>";
		} else {
			// regular html tag
			newHtml = newHtml + nonHtml + htmlOpen + html.substring(idx1 + htmlTagOpen.length, idx2) + htmlClose;
		}
		html = html.substring(idx2 + htmlTagClose.length, html.length);
	}
		
	return replace(newHtml + "" + html, "\n", "<br>\n");

}

function _formatSyntax(text) {

	text = replace(replace(text, '<', '&lt;'), '>', '&gt;');

	var newText = "";

	var idx1, idx2;
	
	while ( (idx1 = text.indexOf(scriptDelimOpen)) > -1) {
		idx2 =text.indexOf(scriptDelimClose);
		if (-1 == idx2) idx2 = text.length;

		html = formatHtml(text.substring(0, idx1));
		script = formatScript(text.substring(idx1, idx2 + scriptDelimClose.length));

		newText = newText + html + script;

		text = text.substring(idx2 + scriptDelimClose.length, text.length);
	}
	text = newText + formatHtml(text);

	return text;
}
